<?php
/**
 * @file
 * Views plugin for argument default value.
 */

/**
 * Default argument plugin to return current page menu trail.
 */
class menu_reference_plugin_argument_default_menu_trail extends views_plugin_argument_default {
  function get_argument() {
    static $menu_links_by_path;
    $active_trail = menu_get_active_trail();

    end($active_trail);
    do {
      $item = current($active_trail);
      $mlids = array();
      if (isset($item['mlid'])) {
        $mlids[] = $item['mlid'];
      }
      elseif ($item['href'] == '<front>' && key($active_trail) == 0) {
        if (isset($menu_links_by_path[$item['href']])) {
          $menu_links = $menu_links_by_path[$item['href']];
        }
        else {
          $menu_links = $menu_links_by_path[$item['href']] = db_query('SELECT mlid FROM {menu_links} WHERE link_path = :link', array(':link' => $item['href']));
        }
        foreach ($menu_links as $link) {
          $mlids[] = $link->mlid;
        }
      }
      if (!empty($mlids)) {
        $result = db_select($this->argument->table)
          ->fields($this->argument->table, array($this->argument->field))
          ->condition($this->argument->field, $mlids, 'IN')
          ->execute()
          ->fetchAssoc();
      }
    } while (empty($result[$this->argument->field]) && prev($active_trail));

    if (!empty($result[$this->argument->field])) {
      return $result[$this->argument->field];
    }
    else {
      return NULL;
    }
  }
}
